/*
** Definition of all erlang commands
**
*/
#ifndef __ERLTK_H__
#define __ERLTK_H__

#define ERL_TK_BIND          0
#define ERL_TK_DESTROY       1
#define ERL_TK_LOWER         2
#define ERL_TK_RAISE         3
#define ERL_TK_BELL          5
#define ERL_TK_BUTTON        6
#define ERL_TK_CHECKBUTTON   7
#define ERL_TK_RADIOBUTTON   8
#define ERL_TK_LABEL         9
#define ERL_TK_UPDATE        11
#define ERL_TK_WINFO         12
#define ERL_TK_WM            13
#define ERL_TK_BINDTAGS      14
#define ERL_TK_CANVAS        17
#define ERL_TK_CLIPBOARD     18
#define ERL_TK_ENTRY         19
#define ERL_TK_FRAME         20
#define ERL_TK_FOCUS         21
#define ERL_TK_GRAB          22
#define ERL_TK_IMAGE         23
#define ERL_TK_LISTBOX       24
#define ERL_TK_MENU          25
#define ERL_TK_MENUBUTTON    26
#define ERL_TK_MESSAGE       27
#define ERL_TK_OPTION        28
#define ERL_TK_PACK          29
#define ERL_TK_PLACE         30
#define ERL_TK_SCALE         31
#define ERL_TK_SCROLLBAR     32
#define ERL_TK_SELECTION     33
#define ERL_TK_TEXT          34
#define ERL_TK_TK            35
#define ERL_TK_CMD           36
#define ERL_TK_GRID          37
#define ERL_TK_TOPLEVEL      38

#define ERL_TK_SETVAR        46
#define ERL_TK_GETVAR        47
#define ERL_TK_EVENT         48

/* Reply codes */
#define TK_ERL_OK            0
#define TK_ERL_ERROR         1
#define TK_ERL_EVENT         2
#define TK_ERL_INVOKE        3
#define TK_ERL_TKERROR       4
#define TK_ERL_TKSCREEN      5

#define TK_OP_OFFSET         0  /* argc is offset into buffer */
#define TK_OP_OPTION         1  /* argc is offset into tkopt[] */
#define TK_OP_STRING         2  /* argc is offset into tkstr[] */

#define GET_INT8(p)  ((p)[0])
#define GET_INT16(p) (((p)[0]<<8) | (p)[1])
#define GET_INT24(p) (((p)[0]<<16) | ((p)[1]<<8) | (p)[2])
#define GET_INT32(p) (((p)[0]<<24) | ((p)[1]<<16) | ((p)[2]<<8) | (p)[3])

#define PUT_INT8(p, x) ((p)[0] = (x))

#define PUT_INT16(p, x) (((p)[0] = ((x) >> 8) & 0xff), \
			 ((p)[1] = (x) & 0xff))

#define PUT_INT24(p, x) (((p)[0] = ((x) >> 16) & 0xff), \
			 ((p)[1] = ((x) >> 8) & 0xff), \
			 ((p)[2] = (x) & 0xff))

#define PUT_INT32(p, x) (((p)[0] = ((x) >> 24) & 0xff), \
			 ((p)[1] = ((x) >> 16) & 0xff), \
			 ((p)[2] = ((x) >> 8) & 0xff), \
			 ((p)[3] = (x) & 0xff))


#endif
